# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Go.gitlab-ci.yml

image: golang:latest

variables:
  # Please edit to your GitLab project
  REPO_NAME: salsa.debian.org/mdosch/go-sendxmpp

# The problem is that to be able to use go get, one needs to put
# the repository in the $GOPATH. So for example if your gitlab domain
# is gitlab.com, and that your repository is namespace/project, and
# the default GOPATH being /go, then you'd need to have your
# repository in /go/src/gitlab.com/namespace/project
# Thus, making a symbolic link corrects this.
before_script:
  - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
  - cd $GOPATH/src/$REPO_NAME

stages:
  - test
  - build
  - deploy

format:
  stage: test
  script:
    - go fmt $(go list ./... | grep -v /vendor/)
    - go vet $(go list ./... | grep -v /vendor/)
    - go test -race $(go list ./... | grep -v /vendor/)

compile_linux-amd64:
  stage: build
  only:
    - tags
  script:
    - env GOOS=linux GOARCH=amd64 go build -race -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/go-sendxmpp
  artifacts:
    paths:
      - go-sendxmpp

compile_linux-arm64:
  stage: build
  only:
    - tags
  script:
    - env GOOS=linux GOARCH=arm64 go build -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/go-sendxmpp
  artifacts:
    paths:
      - go-sendxmpp

compile_linux-386:
  stage: build
  only:
    - tags
  script:
    - env GOOS=linux GOARCH=386 go build -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/go-sendxmpp
  artifacts:
    paths:
      - go-sendxmpp

compile_linux-arm:
  stage: build
  only:
    - tags
  script:
    - env GOOS=linux GOARCH=arm go build -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/go-sendxmpp
  artifacts:
    paths:
      - go-sendxmpp

compile_win386:
  stage: build
  only:
    - tags
  script:
    - env GOOS=windows GOARCH=386 go build -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/go-sendxmpp.exe
  artifacts:
    paths:
      - go-sendxmpp.exe

compile_win64:
  stage: build
  only:
    - tags
  script:
    - env GOOS=windows GOARCH=amd64 go build -ldflags "-extldflags '-static'" -o $CI_PROJECT_DIR/go-sendxmpp.exe
  artifacts:
    paths:
      - go-sendxmpp.exe
